package de.paluno.serviceplatform;

/**
 * 
 * @author Eric Schmieders (eric.schmieders@sse.uni-due.de)
 */
public class Activity {
	private String name;
	private long assumption;
	private long[] dataset;
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public boolean sameAs(Activity a) {
		if (getName().equals(a.getName()))
			return true;
		return false;
	}
	
	public String getPrint(int execution, boolean assumption, boolean monitoringData) {
		String result = "SBAInstance"+execution+":action("+getName()+")";
		result += ((assumption)?":assumption("+getAssumption()+")":""); 
		result += ((monitoringData)?":monitoringData("+getMonitoredResponseTime(execution)+")":"");
		return result+".";
	}
	
	public long getMonitoredResponseTime(int index) {
		return dataset[index];
	}
	
	public long getAssumption() {
		return assumption;
	}
	
	private void setAssumption(long assumption) {
		this.assumption = assumption;
	}

	public Activity(String name, long[] dataset) {
		setName(name);
		setDataSet(dataset);
		
		long total = 0;
		for (long l: dataset)
			total += l;
			
		setAssumption((long)(MonitoringComponent.ASSUMPTION_MODIFIER*(total/(long)dataset.length)));
	}
	
	public Activity(String name, long assumption, long[] dataset) {
		setName(name);
		setAssumption(assumption);
		setDataSet(dataset);
	}

	private void setDataSet(long[] dataset) {
		this.dataset = dataset;
		
	}
}